/*===========================================================================*/
/*
 * This file is part of
 * libneuro - a C++ library for signals in the Neuro format
 *
 * Copyright (C) 2007, 2008  Elaine Tsiang YueLien
 *
 * libneuro is free software; you can redistribute it and/or
 * libogg++java is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, see http://www.gnu.org/licenses,
 * or write to the
 * Free Software Foundation, Inc.
 * 51 Franklin Street, Fifth Floor
 * Boston, MA  02110-1301, USA
 *
 *===========================================================================*/
/** @file JniNeuro.i                                                         *
 *                                                                           *
 *  swig conversion specification for libneuro                               *
 *                                                                           */
/*===========================================================================*/
%module(directors="1") JniNeuro
%{
#include <Neuro/Neuro.H>
%}

%{
    /* Ogg::Exception and derived are deemed severe enough to
     * make impossible the continuing reading or writing of an Ogg stream
     */
%}
     
%exception %{
try {
     $action
     } catch (Ogg::Exception & e)
      {
        jclass excep = jenv->FindClass("java/lang/Exception");
	if (excep)
	 jenv->ThrowNew(excep, e.what());
  	return $null;
	}
       catch (...)
      {
        SWIG_JavaThrowException(jenv, SWIG_JavaRuntimeException,
        			"C++ non Ogg::Exception thrown");
  	return $null;
	}
%}

%include <std_string.i>
%include <glib_ustring.i>
%include <arrays_java.i>
%apply signed char[] {signed char *};
%include <std_map.i>
%import <JniOgg.i>
%import <JniALingA.i>

%typemap(javafinalize) SWIGTYPE "" 

%typemap (javaimports) Neuro::Neuro %{
import org.gnutopia.ogg.*;
import org.gnutopia.alinga.*;
%} 
%pragma(java) jniclassimports="
import org.gnutopia.ogg.*;
import org.gnutopia.alinga.*;
"
%rename("nextFrame") operator ++;
%nodefaultctor Neuro::iFrames;
%ignore selectCallback;
// The java side needs to delete
// iFrames objects to execute
// last frame rites
%newobject Neuro::Neuro::write;
%newobject Neuro::Neuro::read;
%include "Cni/Neuro.H"

%{
namespace Neuro
{
  typedef Neuro::iFrames iFrames;
}
%}
